## actor-framework 0.18.0~rc1

=== debian/changelog ===
actor-framework (0.18.0~rc1-1) experimental; urgency=medium

  * New upstream version 0.18.0~rc1
  * Modernize debian/watch
  * Bump package name according to SONAME change
  * Drop/update patches
  * Update build rules. Doxygen documentation seems to have vanished 
    from upstream's build scripts, though.

 -- Hilko Bengen <bengen@debian.org>  Thu, 24 Dec 2020 02:37:18 +0100
