=== debian/control ===
Source: actor-framework
Priority: optional
Maintainer: Hilko Bengen <bengen@debian.org>
Build-Depends: debhelper (>= 12~),
 cmake,
 libssl-dev,
# ocl-icd-opencl-dev,
# python3-pybind11, pybind11-dev,
 libcurl4-openssl-dev,
 doxygen, pandoc, python3-pandocfilters, graphviz,
Standards-Version: 4.3.0
Section: libs
Homepage: http://www.actor-framework.org/

Package: libcaf-dev
Section: libdevel
Architecture: any
Depends: libcaf-core0.18 (= ${binary:Version}),
 libcaf-io0.18 (= ${binary:Version}),
 libcaf-openssl0.18 (= ${binary:Version}),
 ${misc:Depends}
Recommends: libcaf-doc
Description: Implementation of the Actor Model in C++, development files
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains headers and other files required to develop
 applications against the library.

Package: libcaf-core0.18
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of the Actor Model in C++, core library
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains the core library.

Package: libcaf-io0.18
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of the Actor Model in C++, I/O library
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains the io library required for network transparency.

Package: libcaf-openssl0.18
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of the Actor Model in C++, OpenSSL library
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains the io library required for TLS encryption
 using OpenSSL.

Package: libcaf-doc
Section: doc
Architecture: all
Breaks: libcaf-dev (<< 0.16.3)
Replaces: libcaf-dev (<< 0.16.3)
Depends: ${misc:Depends}
Description: Implementation of the Actor Model in C++, development files
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains documentation and examples for the library.
