=== debian/changelog ===
actor-framework (0.18.7-1~exp1) experimental; urgency=medium

  * New upstream version 0.18.7
  * Add patch for missing include needed with newer GCC

 -- Hilko Bengen <bengen@debian.org>  Fri, 28 Jul 2023 20:51:47 +0200

actor-framework (0.18.6-1) experimental; urgency=medium

  * New upstream version 0.18.6
  * Add gbp.conf
  * Bump Standards-Version, Debhelper compat level
  * Update patches

 -- Hilko Bengen <bengen@debian.org>  Sun, 08 Jan 2023 14:11:55 +0100
