=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: actor-framework
 Priority: optional
 Maintainer: Hilko Bengen <bengen@debian.org>
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper-compat (=13),
  cmake,
  libssl-dev,
 # ocl-icd-opencl-dev,
 # python3-pybind11, pybind11-dev,
  libcurl4-openssl-dev,
  doxygen, pandoc, python3-pandocfilters, graphviz,
-Standards-Version: 4.3.0
+Standards-Version: 4.6.1
 Section: libs
 Homepage: http://www.actor-framework.org/
