=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

override_dh_install:
	mkdir -p debian/tmp/usr/share/doc/libcaf-doc
	mv -t debian/tmp/usr/share/doc/libcaf-doc \
	      debian/tmp/usr/share/caf/*
	dh_install

override_dh_missing:
	dh_missing --fail-missing

%:
	dh $@ --buildsystem=cmake
