=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/actor-framework-$1\.tar\.gz/,\
  versionmangle=s/-rc[.]?/~rc/ \
  https://github.com/actor-framework/actor-framework/tags .*/v?(\d\S*)\.tar\.gz
